/*-
 * Copyright (C)2015 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: pgoblin_job.h,v 1.1 2015/07/13 19:34:05 babolo Exp $
 */

#ifndef _PGOBLIN_JOB_H_
#define _PGOBLIN_JOB_H_

__BEGIN_DECLS

typedef struct pgoblin_jobreg {
#ifdef _MULTILAR_H_
    mular_descriptor*pids;                         /* Child processes register set                   */
#else
    void            *pids;
#endif
    char            *host;
    u_int32_t        flags;
#   define           PGOBLIN_JOB_TYPE     0x00000F
#   define           PGOBLIN_HOSTJFREE    0x004000 /* Free job host when pgoblin_jobreg destoyed     */
#   define           PGOBLIN_INITED       0x040000 /* initialisedsed                                 */
#   define           PGOBLIN_KQUEUED      0x080000 /* kq created and used                            */
#   define           PGOBLIN_ERROR_SENSOR 0x400000 /* Eror reaction                                  */
#   define           PGOBLIN_ERROR_SENSIB (PGOBLIN_ERROR_SENSOR << 1) /* Immediate error reaction    */
/*                   BLINflag                         copied from pgoblin_main                       */
    u_int32_t        concur;
    u_int32_t        dead;
    int              kq;
} pgoblin_jobreg;

typedef struct pgoblin_jobl {
    ssize_t          cmdn;
    pid_t            pid;
    int              status;
#   define           PGOBLIN_NOSTATUS (-1)
#   define           PGOBLIN_LOSTSTAT 0x00010000
} pgoblin_jobl;

typedef struct pgoblin_dir {
    void      *dirp;
    int           i; /*   ,                */
    int           f; /*          */
    int           g; /* 1 -  ; 0 -                         */
    char       *ent;
    struct stat *sb;
} pgoblin_dir;

__END_DECLS

#endif /* !_PGOBLIN_JOB_H_ */
